stages:
  - build_and_test
  - containerize
  - deploy

build_and_test:
  stage: build_and_test
  image: node:latest
  tags:
    - lutdevops2023
  script:
    - npm install
    - npm test

containerize:
  stage: containerize
  image: docker:latest
  tags:
    - lutdevops2023
  services:
    - docker:dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    # build and tag the image (refer to the gitlab container registry for the correct tagname)
    - docker build -t registry.gitlab.com/marko.j.repo/my-devops-project .
    # push the image to the gitlab container registry
    - docker push registry.gitlab.com/marko.j.repo/my-devops-project

deploy:
  stage: deploy
  script:
    - echo "Deploy to Azure App Service"
  environment:
    name: production environment
    url: https://my-lut-devops-inst.azurewebsites.net/
    
